#include <gnome.h>

#include <gst/gst.h>

#include "gsteditor.h"
#include "gsteditorelement.h"
#include "elementselect.h"

/* signals and args */
enum {
  ENTER_CHILD,
  LEAVE_CHILD,
  LAST_SIGNAL
};

enum {
  ARG_0,
};

static void gst_editor_class_init(GstEditorClass *klass);
static void gst_editor_init(GstEditor *editor);

static gint gst_editor_event(GtkWidget *widget,GdkEvent *event);

/*
static void gst_editor_enter_child();
static void gst_editor_leave_child();
*/

static GnomeCanvasClass *parent_class = NULL;

GtkType gst_editor_get_type(void) {
  static GtkType editor_type = 0;

  if (!editor_type) {
    static const GtkTypeInfo editor_info = {
      "GstEditor",
      sizeof(GstEditor),
      sizeof(GstEditorClass),
      (GtkClassInitFunc)gst_editor_class_init,
      (GtkObjectInitFunc)gst_editor_init,
      NULL,
      NULL,
      (GtkClassInitFunc)NULL,
    };
    editor_type = gtk_type_unique(gnome_canvas_get_type(),&editor_info);
  }
  return editor_type;
}

static void gst_editor_class_init(GstEditorClass *klass) {
  GtkWidgetClass *widget_class;

  widget_class = (GtkWidgetClass*)klass;

  parent_class = gtk_type_class(gnome_canvas_get_type());

/*
  klass->enter_child = gst_editor_enter_child;
  klass->leave_child = gst_editor_leave_child;
*/

  widget_class->event = gst_editor_event;
}

static void gst_editor_init(GstEditor *editor) {
  editor->element_group = GNOME_CANVAS_GROUP(gnome_canvas_item_new(
                          gnome_canvas_root(GNOME_CANVAS(editor)),
                          gnome_canvas_group_get_type(),NULL));
  editor->in_child = 0;
}

GstEditor *gst_editor_new() {
  GstEditor *editor;

  editor = gtk_type_new(gst_editor_get_type());

  return editor;
}

gint gst_editor_event(GtkWidget *widget,GdkEvent *event) {
  GstEditor *editor = GST_EDITOR(widget);
  g_print("editor->in_child is %d\n",editor->in_child);
  if (editor->in_child > 0) return FALSE;
//  g_print("editor %p got event %d\n",editor,event->type);
  if (event->type == GDK_BUTTON_PRESS) {
    gdouble x,y;
    GstElementFactory *factory;
    gnome_canvas_window_to_world(GNOME_CANVAS(editor),
                                 event->button.x,event->button.y,
                                 &x,&y);
    g_print("editor %p got button press at %f,%f\n",editor,x,y);
    factory = element_select_dialog();
    if (factory) {
//      GnomeCanvasItem *element =
      gnome_canvas_item_new(editor->element_group,
                            gst_editor_element_get_type(),
                            "x",x,"y",y,
                            "width",40.0,"height",20.0,
                            "factory",factory,
                            NULL);
    }
    return TRUE;
  }
  return FALSE;
}
