#ifndef __GST_EDITOR_H__
#define __GST_EDITOR_H__

#include <gtk/gtk.h>
#include <gnome.h>
#include <gst/gst.h>

#define GST_TYPE_EDITOR \
  (gst_editor_get_type())
#define GST_EDITOR(obj) \
  (GTK_CHECK_CAST((obj),GST_TYPE_EDITOR,GstEditor))
#define GST_EDITOR_CLASS(klass) \
  (GTK_CHECK_CLASS_CAST((klass),GST_TYPE_EDITOR,GstEditor))
#define GST_IS_EDITOR(obj) \
  (GTK_CHECK_TYPE((obj),GST_TYPE_EDITOR))
#define GST_IS_EDITOR_CLASS(obj) \
  (GTK_CHECK_CLASS_TYPE((klass),GST_TYPE_EDITOR)))

typedef struct _GstEditor GstEditor;
typedef struct _GstEditorClass GstEditorClass;

struct _GstEditor {
  GnomeCanvas canvas;

  GnomeCanvasGroup *link_group;
  GnomeCanvasGroup *element_group;

  gint in_child;

  GList *elements;
};

struct _GstEditorClass {
  GnomeCanvasClass parent_class;

  void (*enter_child)();
  void (*leave_child)();
};


GtkType gst_editor_get_type();
GstEditor *gst_editor_new();

#endif /* __GST_EDITOR_H__ */
