#ifndef __GST_EDITOR_ELEMENT_H__
#define __GST_EDITOR_ELEMENT_H__

#include <gnome.h>

#define GST_TYPE_EDITOR_ELEMENT \
  (gst_editor_element_get_type())
#define GST_EDITOR_ELEMENT(obj) \
  (GTK_CHECK_CAST((obj),GST_TYPE_EDITOR_ELEMENT,GstEditorElement))
#define GST_EDITOR_ELEMENT_CLASS(klass) \
  (GTK_CHECK_CLASS_CAST((klass),GST_TYPE_EDITOR_ELEMENT,GstEditorElement))
#define GST_IS_EDITOR_ELEMENT(obj) \
  (GTK_CHECK_TYPE((obj),GST_TYPE_EDITOR_ELEMENT))
#define GST_IS_EDITOR_ELEMENT_CLASS(obj) \
  (GTK_CHECK_CLASS_TYPE((klass),GST_TYPE_EDITOR_ELEMENT)))

typedef struct _GstEditorElement GstEditorElement;
typedef struct _GstEditorElementClass GstEditorElementClass;

struct _GstEditorElement {
  GnomeCanvasGroup group;

  /* the actual element details */
  GstElementFactory *factory;
  GstElementFactory *element;
  gchar *name;

  /* visual stuff */
  gboolean created;
  gdouble x,y,width,height;
  gboolean resized;

  GnomeCanvasItem *border;
  GnomeCanvasItem *title;
};

struct _GstEditorElementClass {
  GnomeCanvasGroupClass parent_class;

  /* these are used to hack around the lack of stackable [sg]et_args */
  void (*group_set_arg) (GtkObject *object,GtkArg *arg,guint arg_id);
  void (*group_get_arg) (GtkObject *object,GtkArg *arg,guint arg_id);
};

GtkType gst_editor_element_get_type();

#endif /* __GST_EDITOR_ELEMENT_H__ */
