/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __GST_ELEMENTFACTORY_H__
#define __GST_ELEMENTFACTORY_H__


#include <gst/gstobject.h>
#include <gst/gstelement.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef struct _GstElementFactory GstElementFactory;
typedef struct _GstElementDetails GstElementDetails;

struct _GstElementFactory {
  gchar *name;
  GtkType type;

  GstElementDetails *details;
};

struct _GstElementDetails {
  gchar *longname;		/* long, english name */
  gchar *class;			/* type of element, kinda */
  gchar *description;		/* insights of one form or another */
  gchar *version;		/* version of the element */
  gchar *author;		/* who wrote this thing? */
  gchar *copyright;		/* copyright details (year, etc.) */
};



GstElementFactory* gst_elementfactory_new(gchar *name,GtkType type,
                                          GstElementDetails *details);
void gst_elementfactory_register(GstElementFactory *elementfactory);

GstElementFactory *gst_elementfactory_find(gchar *name);
GList *gst_elementfactory_get_list();

GstElement *gst_elementfactory_create(GstElementFactory *factory,
                                      gchar *name);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GST_ELEMENTFACTORY_H__ */     

