#!/bin/sh
if [ $# -eq 0 ];then
  echo "usage: $0 GroupObject/Group_Object [GroupParent/Group_Parent]"
  exit
fi

name=$1
if [ $# -gt 1 ];then
  parent=$1
else
  parent=GtkObject
fi

if `echo $name | grep -v '_' > /dev/null`;then
  if [ `echo $name | sed 's/[^A-Z]//g' | wc -c` -gt 1 ];then
    name=`echo $name | sed 's/\([A-Z]\)/_\1/g' | sed 's/^_//'`
  else
    echo "can't work with this, not enough components"
    exit 1
  fi
fi

if `echo $parent | grep -v '_' > /dev/null`;then
  if [ `echo $parent | sed 's/[^A-Z]//g' | wc -c` -gt 1 ];then
    name=`echo $parent | sed 's/\([A-Z]\)/_\1/g' | sed 's/^_//'`
  else
    echo "can't work with this, not enough components in parent"
    exit 1
  fi
fi

Group=`echo $name | sed 's/^\([^_]*\)_.*$/\1/'`
Object=`echo $name | sed 's/^[^_]*_\(.*\)/\1/'`
ShortObject=`echo $Object | sed 's/_//g'`
group=`echo $Group | tr 'A-Z' 'a-z'`
object=`echo $Object | tr 'A-Z' 'a-z'`
shortobject=`echo $object | sed 's/_//g'`
GROUP=`echo $Group | tr 'a-z' 'A-Z'`
OBJECT=`echo $Object | tr 'a-z' 'A-Z'`
SHORTOBJECT=`echo $OBJECT | sed 's/_//g'`

PGgroup=`echo $parent | sed 's/^\([^_]*\)_.*$/\1/'`
PObject=`echo $parent | sed 's/^[^_]*_\(.*\)/\1/'`
PShortObject=`echo $PObject | sed 's/_//g'`
pgroup=`echo $PGroup | tr 'A-Z' 'a-z'`
pobject=`echo $PObject | tr 'A-Z' 'a-z'`
pshortobject=`echo $pobject | sed 's/_//g'`
PGROUP=`echo $PGroup | tr 'a-z' 'A-Z'`
POBJECT=`echo $PObject | tr 'a-z' 'A-Z'`
PSHORTOBJECT=`echo $POBJECT | sed 's/_//g'`


cat groupobject.h | \
sed -e "s/pgroup/$pgroup/g" \
    -e "s/PGroup/$PGroup/g" \
    -e "s/PGROUP/$PGROUP/g" \
    -e "s/_pobject/_$pobject/g" \
    -e "s/_PObject/_$PObject/g" \
    -e "s/_POBJECT/_$POBJECT/g" \
    -e "s/\([^_]\)pobject/\1$pobject/g" \
    -e "s/\([^_]\)PObject/\1$PObject/g" \
    -e "s/\([^_]\)POBJECT/\1$POBJECT/g" | \
sed -e "s/group/$group/g" \
    -e "s/Group/$Group/g" \
    -e "s/GROUP/$GROUP/g" \
    -e "s/_object/_$object/g" \
    -e "s/_Object/_$Object/g" \
    -e "s/_OBJECT/_$OBJECT/g" \
    -e "s/\([^_]\)object/\1$object/g" \
    -e "s/\([^_]\)Object/\1$Object/g" \
    -e "s/\([^_]\)OBJECT/\1$OBJECT/g" > $group$object.h

cat groupobject.c | \
sed -e "s/pgroup/$pgroup/g" \
    -e "s/PGroup/$PGroup/g" \
    -e "s/PGROUP/$PGROUP/g" \
    -e "s/_pobject/_$pobject/g" \
    -e "s/_PObject/_$PObject/g" \
    -e "s/_POBJECT/_$POBJECT/g" \
    -e "s/\([^_]\)pobject/\1$pobject/g" \
    -e "s/\([^_]\)PObject/\1$PObject/g" \
    -e "s/\([^_]\)POBJECT/\1$POBJECT/g" | \
sed -e "s/group/$group/g" \
    -e "s/Group/$Group/g" \
    -e "s/GROUP/$GROUP/g" \
    -e "s/_object/_$object/g" \
    -e "s/_Object/_$Object/g" \
    -e "s/_OBJECT/_$OBJECT/g" \
    -e "s/\([^_]\)object/\1$object/g" \
    -e "s/\([^_]\)Object/\1$Object/g" \
    -e "s/\([^_]\)OBJECT/\1$OBJECT/g" > $group$object.c
